<template>
  <div>
    <el-select
      v-show="false"
      v-model="ExpandedNum"
      @change="handleExpandNumChange"
      placeholder="选择展开级别"
      size="mini"
      style="width: 100px; left: 0px"
    >
      <el-option label="不展开" :value="0"></el-option>
      <el-option label="展开1" :value="1"></el-option>
      <el-option label="展开2" :value="2"></el-option>
      <el-option label="展开3" :value="3"></el-option>
    </el-select>
    <!-- 过滤筛选: <el-input v-model="search" clearable size="small" style="width: 250px" placeholder="筛选数据"/>
     <el-button @click="exportExcel" style="float:right;margin-bottom:10px" size="small" type="primary">导出Excel文件</el-button>
    <el-button @click="exporeCSV(tables)" size="small" type="primary" style="float:right;margin-right:10px;margin-bottom:10px">导出CSV文件</el-button> -->
    <u-table
      stripe
      class="xshou"
      ref="plTreeTable"
      header-cell-class-name="table_header"
      fixed-columns-roll
      :data="tableData"
      :row-height="rowHeight"
      :height="vth"
      :treeConfig="{
        children: 'children',
        iconClose: 'el-icon-arrow-right',
        iconOpen: 'el-icon-arrow-down',
        expandAll: true,
      }"
      @toggle-tree-expand="toggleTreeExpand"
      use-virtual
      row-id="id"
      border
    >
      <u-table-column
        prop="name"
        :label="typedata"
        :treeNode="true"
        :showOverflowTooltip="true"
        :show-overflow-tooltip="true"
        min-width="300"
      ></u-table-column>
      <u-table-column
        align="center"
        prop="voltageLevel"
        label="电压等级"
        min-width="120"
      >
        <template slot-scope="scope">
          <span
            v-if="scope.row.voltageLevel == null"
            type="primary"
            size="small"
            >/</span
          >
          <span
            v-if="scope.row.voltageLevel != null"
            type="primary"
            size="small"
            >{{ scope.row.voltageLevel }}</span
          >
        </template>
      </u-table-column>
      <u-table-column
        align="center"
        prop="factoryName"
        label="厂家"
        min-width="100"
      >
        <template slot-scope="scope">
          <span v-if="scope.row.factoryName == null" type="primary" size="small"
            >/</span
          >
          <span
            v-if="scope.row.factoryName != null"
            type="primary"
            size="small"
            >{{ scope.row.factoryName }}</span
          >
        </template>
      </u-table-column>
      <u-table-column
        align="center"
        prop="networkParam"
        label="网络参数"
        min-width="120"
      >
        <template slot-scope="scope">
          <span
            v-if="scope.row.networkParam == null"
            type="primary"
            size="small"
            >/</span
          >
          <span
            v-if="scope.row.networkParam != null"
            type="primary"
            size="small"
            >{{ scope.row.networkParam }}</span
          >
        </template>
      </u-table-column>
      <u-table-column
        align="center"
        prop="lineName"
        label="监测点名称"
        min-width="120"
      >
        <template slot-scope="scope">
          <span v-if="scope.row.lineName == null" type="primary" size="small"
            >/</span
          >
          <span v-if="scope.row.lineName != null" type="primary" size="small">{{
            scope.row.lineName
          }}</span>
        </template>
      </u-table-column>
      <u-table-column
        align="center"
        prop="steadyExceedRate"
        label="符合性占比(%)"
        
        min-width="100"
      >
        <template slot-scope="scope">
          <span
            v-if="scope.row.steadyExceedRate == 3.14159"
            type="primary"
            size="small"
            >暂无数据</span
          >
          <span
            v-if="scope.row.steadyExceedRate != 3.14159"
            type="primary"
            size="small"
            >{{ scope.row.steadyExceedRate }}</span
          >
        </template>
      </u-table-column>
    </u-table>
    <!-- <pagination :pageData="pageData" @changePageNum="changePageNum" @changePageSize="changePageSize"></pagination> -->
  </div>
</template>
<script>
// import {getheight} from '../../assets/commjs/common'
// import pagination from '../components/pagination/index'
import FileSaver from "file-saver";
import XLSX from "xlsx";
import json2csv from "json2csv";
export default {
  computed: {
    // 实时监听表格
    // tables: function() {
    //     const search = this.search
    //     if (search) {
    //         return this.tableData.filter(dataNews => {
    //             return Object.keys(dataNews).some(key => {
    //                 return String(dataNews[key]).toLowerCase().indexOf(search) > -1
    //             })
    //         })
    //     }
    //     return this.tableData
    // }
    // vth() {
    //   return window.sessionStorage.getItem("appheight") - 115;
    // },
  },
  data() {
    return {
      ExpandedNum: 3,
      rowHeight: 20,
      expandID: [],
      search: "",
      typedata: "电网拓扑",
      tableheight: undefined,
      vth: null,
    };
  },
  watch: {
    classvalue: function (a, b) {
      if (a == "Power_Network") {
        this.typedata = "电网拓扑";
      } else if (a == "Manufacturer") {
        this.typedata = "终端厂家";
      } else if (a == "Voltage_Level") {
        this.typedata = "电压等级";
      } else if (a == "Load_Type") {
        this.typedata = "干扰源类型";
      }
    },
    tableData: function (a, b) {
      if (a.length > 0) {
        this.tableData = a;
        this.handleExpandNumChange();
      }
    },
  },
  props: {
    classvalue: {
      type: String,
      default: undefined,
    },
    tableData: {
      type: Array,
      default: [],
    },
    loading: {
      type: Boolean,
      default: false,
    },
  },
  components: {
    // pagination
  },
  created() {},
  mounted() {
  
    this.handleExpandNumChange();
    // this.tableheight = ((getheight())*1.91)
    this.setHeight()
        window.addEventListener('resize', this.setHeight)
    },
    beforeDestroy() {
        window.removeEventListener('resize', this.setHeight)
    },
    methods: {
        setHeight() {
          this.vth = window.sessionStorage.getItem("appheight") - 115 + "px";
          
        },
    //判断需要展开层级
    handleExpandNumChange() {
      if (this.ExpandedNum > 0) {
        this.setExpandKeys(this.tableData);
      }
    },
    //层级展开递归方法
    setExpandKeys(dataList, n) {
      if (!n) n = 1;
      for (let i = 0; i < dataList.length; i++) {
        if (n <= this.ExpandedNum) {
          //this.expandID=[]
          this.expandID.push(`${dataList[i].id}`);
          if (dataList[i].hasOwnProperty("children")) {
            const children = dataList[i].children;
            this.setExpandKeys(children, n + 1);
          }
        }
      }
    },
    toggleTreeExpand() {},
    // 判断是否IE浏览器
    MyBrowserIsIE() {
      let isIE = false;
      if (
        navigator.userAgent.indexOf("compatible") > -1 &&
        navigator.userAgent.indexOf("MSIE") > -1
      ) {
        // ie浏览器
        isIE = true;
      }
      if (navigator.userAgent.indexOf("Trident") > -1) {
        // edge 浏览器
        isIE = true;
      }
      return isIE;
    },
    //创建a标签下载
    createDownLoadClick(content, fileName) {
      const link = document.createElement("a");
      link.href = encodeURI(content);
      link.download = fileName;
      document.body.appendChild(link);
      link.click();
      document.body.removeChild(link);
    },
    exporeCSV(rows) {
      try {
        const result = json2csv.parse(rows, {
          // fields: fields,
          excelStrings: true,
        });
        if (this.MyBrowserIsIE()) {
          // IE10以及Edge浏览器
          var BOM = "\uFEFF";
          // 文件转Blob格式
          var csvData = new Blob([BOM + result], { type: "text/csv" });
          navigator.msSaveBlob(csvData, `导出数据.csv`);
        } else {
          let csvContent = "data:text/csv;charset=utf-8,\uFEFF" + result;
          // 非ie 浏览器
          this.createDownLoadClick(csvContent, `导出数据.csv`);
        }
      } catch (err) {
        alert(err);
      }
    },
    exportExcel() {
      /* generate workbook object from table */
      let wb = XLSX.utils.table_to_book(
        document.querySelector("#rebateSetTable")
      );
      /* get binary string as output */
      let wbout = XLSX.write(wb, {
        bookType: "xlsx",
        bookSST: true,
        type: "array",
      });
      try {
        FileSaver.saveAs(
          new Blob([wbout], { type: "application/octet-stream" }),
          "数据表.xlsx"
        );
      } catch (e) {
        if (typeof console !== "undefined") {}//console.log(e, wbout);
      }
      return wbout;
    },
    changePageNum(data) {
      this.pageData.pageNum = data;
      alert("父组件当前页" + this.pageData.pageNum);
    },
    changePageSize(data) {
      this.pageData.pageSize = data;
      alert("父组件当前条数" + this.pageData.pageSize);
    },
  },
};
</script>
<style lang="scss" scoped>
.xshou {
  cursor: pointer;
}
// ::v-deep .u-table__body-wrapper {
//     height: calc(100% - 30px) !important;
//     //overflow-x: scroll !important;
// }
// ::v-deep.plTableBox
//   .el-table--striped
//   .el-table__body
//   tr.el-table__row--striped
//   td {
//   background-color: $whirt !important;
// }
// ::v-deep.plTableBox
//   .el-table--striped
//   .el-table__body
//   tr.el-table__row--striped.current-row
//   td {
//   background-color: $current-blue !important;
//   color: #fff !important;
// }
</style>